<?
/* stdlib.php (c) 2000 Ying Zhang (ying@zippydesign.com)
 *
 * TERMS OF USAGE:
 * This file was written and developed by Ying Zhang (ying@zippydesign.com)
 * for educational and demonstration purposes only.  You are hereby granted the
 * rights to use, modify, and redistribute this file as you like.  The only
 * requirement is that you must retain this notice, without modifications, at
 * the top of your source code.  No warranties or guarantees are expressed or
 * implied. DO NOT use this code in a production environment without
 * understanding the limitations and weaknesses pretaining to or caused by the
 * use of these scripts, directly or indirectly. USE AT YOUR OWN RISK!
 */

function nvl(&$var, $default="") {
/* if $var is undefined, return $default, otherwise return $var */

        return isset($var) ? $var : $default;
}

function strip_querystring($url) {
/* takes a URL and returns it without the querystring portion */

        if ($commapos = strpos($url, '?')) {
                return substr($url, 0, $commapos);
        } else {
                return $url;
        }
}

function get_referer() {
/* returns the URL of the HTTP_REFERER, less the querystring portion */

	$HTTP_REFERER = getenv("HTTP_REFERER");
	return strip_querystring(nvl($HTTP_REFERER));
}

function me() {
/* returns the name of the current script, without the querystring portion.
 * this function is necessary because PHP_SELF and REQUEST_URI and PATH_INFO
 * return different things depending on a lot of things like your OS, Web
 * server, and the way PHP is compiled (ie. as a CGI, module, ISAPI, etc.) */

	if (getenv("REQUEST_URI")) {
		$me = getenv("REQUEST_URI");

	} elseif (getenv("PATH_INFO")) {
		$me = getenv("PATH_INFO");

	} elseif ($GLOBALS["PHP_SELF"]) {
		$me = $GLOBALS["PHP_SELF"];
	}

	return strip_querystring($me);
}

function qualified_me() {
/* like me() but returns a fully URL */

	$HTTPS = getenv("HTTPS");
	$SERVER_PROTOCOL = getenv("SERVER_PROTOCOL");
	$HTTP_HOST = getenv("HTTP_HOST");

	$protocol = (isset($HTTPS) && $HTTPS == "on") ? "https://" : "http://";
	$url_prefix = "$protocol$HTTP_HOST";
	return $url_prefix . me();
}

function match_referer($good_referer = "") {
/* returns true if the referer is the same as the good_referer.  If
 * good_refer is not specified, use qualified_me as the good_referer */

	if ($good_referer == "") { $good_referer = qualified_me(); }
	return $good_referer == get_referer();
}

function nocache() {
header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
                                                      // always modified
header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
header ("Pragma: no-cache");                          // HTTP/1.0
}

function up_counter($filename) {
  if (file_exists($filename)) {
    $fil = fopen($filename, 'r');
    $dat = fread($fil, filesize($filename));
#    echo $dat+1;
    fclose($fil);
    $fil = fopen($filename, 'w');
    fwrite($fil, $dat+1);
  }
  else {
    $fil = fopen($filename, 'w');
    fwrite($fil, 1);
#    echo '1';
    fclose($fil);
  }
}

function relocate($newlocation) {
  global $_SERVER, $PHPSESSID;

  if (empty($_SERVER["HTTP_COOKIE"]) && !empty($PHPSESSID)) {
    if (strstr($newlocation,"?"))
      $newlocation .= "&PHPSESSID=" . $PHPSESSID;
    else
      $newlocation .= "?PHPSESSID=" . $PHPSESSID;
  }
  header("Location: " . $newlocation);
  die;
  return;
}
?>
